#!/usr/bin/perl

##
## make html from prehtml
## Muquit, Sept, 1999
#####################################

my $td="..";

my $prehtml_dir="./";
my $html_dir="$td/Count2.6";
my $htmlpp="./htmlpp.sh";

my @prehtmsa='';
my $file='';
my $html='';
my $command='';
my $rc=0;
my $cver="2.6";


my $argc=$#ARGV+1;

my @excludea=
(
        "all.prehtml",
        "macros.prehtml",
        "release.prehtml",
        "exec.prehtml",
        "authdb.prehtml",
        "db_compare.prehtml",
        "compile_NT.prehtml",
        "compile_unix.prehtml",
        "ds_algorithm.prehtml",
        "vislog.prehtml",
        "ttf.prehtml",
        "composite.prehtml",
        "test.prehtml",
        "howtocall.prehtml",
        "digitstyles.prehtml",
        "otherstyles.prehtml",
        "imagestrip.prehtml",
        "announcement.prehtml",
);

# if compile_unix.prehtml is younger than $html_dir/compile.html then
# create $html_dir/compile.html from compile.prehtml
my %excl_touch=
(
    "compile_unix.prehtml"   =>  "compile.html",
    "authdb.prehtml"         =>  "database.html",
    "authdb.prehtml"         =>  "editdb.html",
    "authdb.prehtml"         =>  "count_admin.html",
    "db_compare.prehtml"     =>  "database.html",
    "ds_algorithm.prehtml"   =>  "database.html",
    "vislog.prehtml"         =>  "logfiles.html",
    "ttf.prehtml"            =>  "fonts.html",
    "composite.prehtml"      =>  "iman.html",
    "test.prehtml"           =>  "compile.html",
    "howtocall.prehtml"      =>  "compile.html",
    "digitstyles.prehtml"    =>  "fonts.html",
    "otherstyles.prehtml"    =>  "fonts.html",
    "imagestrip.prehtml"     =>  "fonts.html",
);



opendir(PDIR,$prehtml_dir) or die "could not open directory: $$prehtml_dir";

for (readdir(PDIR))
{
    push(@prehtmsa,$_) unless /^\.{1,2}$/;
}

    foreach (@prehtmsa)
    {
        if (/\.prehtml$/)
        {
           $file="$_";
           if (&exCludePrehtml($file) == 1)
           {
               next;
           }
           if ($file eq "Count.prehtml")
           {
                $rc=&prehtmlChanged($file,"$td/Count.html");
                if ($rc == 1)
                {
                    $command="$htmlpp $file -o $td/Count.html";
                    print "$command\n";
                    system($command);
                    # add the nav to Count.html
                    open(XFD,">>$td/Count.html");
                    print XFD<<EOF;
<p>
    <table border=0 cellspacing=0 cellpadding=0 width=50%>
        <tr>
            <td bgcolor="#6699cc" colspan=2>
               <table border=0 cellspacing=0 cellpadding=0>
                    <tr>
                        <td height=2></td>
                    </tr>
               </table>

            </td>
        </tr>
    </table>

<p>
<a href="Count${cver}/qs.html"><img src="Count${cver}/images/next.png"
alt="[Next]"
border=1></a>
EOF
;
            close(XFD);


                }
           }
           elsif ($file eq "CountNT.prehtml")
           {
                $rc=&prehtmlChanged($file,"$td/CountNT.html");
                if ($rc == 1)
                {
                    $command="$htmlpp $file -o $td/CountNT.html";
                    print "$command\n";
                    system($command);

                }
           }
           else
           {
                $html=$file;
                $html =~ s/\.prehtml/\.html/;            
                $rc=&prehtmlChanged($file,"$html_dir/$html");
                if ($rc == 1)
                {
                    $command="$htmlpp $file -o $html_dir/$html";
                    print "$command\n";
                    system($command);
                }
           }
        }
    }

    #
    # now check if any excluded file has changed
    foreach $file (keys %excl_touch)
    {
        $rc=&prehtmlChanged($file,"$html_dir/$excl_touch{$file}");
        if ($rc == 1)
        {
            my $p=$excl_touch{$file};
            $p =~ s/\.html/\.prehtml/;
            $command="$htmlpp $p -o $html_dir/$excl_touch{$file}";
            print " $command\n";
            system($command);
        }
    }

#
# arg: file1, file2
# returns 1 if file 1 is newer than file 2, 0 otherwise
#
sub prehtmlChanged
{
    my $file_prehtml=shift;
    my $file_html=shift;
    my @fa=();
    my @fb=();
    my $pt;
    my $ht;

    @fa=stat($file_prehtml);
    @fb=stat($file_html);

    # last modified time
    $pt=$fa[9];
    $ht=$fb[9];

    if ($pt and ($pt > $ht))
    {
        return(1);  # changed
    }

    return (0);
}

# returns 1 if needed to be excluded
sub exCludePrehtml
{
    my $file=shift;
    my $a;

    foreach $a (@excludea)
    {
        if ($a eq $file)
        {
            return(1);
        }
    }

    return(0);
}
