#!/usr/bin/perl

# muquit, Sep-04-1999
# make a one big html from prehtml file. it creates a template for
# htmlpp by scanning the table of contents prehtml file. that file
# then used by htmlpp to generate the big html file
use strict;


my $argc=$#ARGV+1;
my $me=$0;
$me =~ s!.*/!!;
my $g_debug=0;

my $usage="
(mkaio - make all in one)
(make big html file from all prehtml file, -- muquit)

usage: $me toc.prehtml

";

my $hline="
    <table border=0 cellspacing=0 cellpadding=0 width=\"50%\">
        <tr>
            <td bgcolor=\"#6699cc\" colspan=2>
               <table border=0 cellspacing=0 cellpadding=0>
                    <tr>
                        <td height=2></td>
                    </tr>
               </table>

            </td>
        </tr>
    </table>
";

if ($argc != 1)
{
    print STDERR $usage;
    exit;
}
my $tocfile=$ARGV[0];

my ($line,$junk,$page)='';

my $cver="2.6";
my $dir="./Count${cver}";

my @pagea=();

open(TFD,$tocfile) or die "could not open toc file: $tocfile: $!";


while (<TFD>)
{
    $line=$_;
    chomp($line);

    $line =~ s/^\s+//g;
    if ($line =~ /^<li>/)
    {
        ($junk,$page)=split(/\//,$line);
        $page =~ s/\".*//g;
        if ($page and $page =~ /\.html/)
        {
            $page =~ s/<#d>/Count${cver}/g;
            if ($page !~ /.html#/)
            {
                if ($page eq "examples.html" or
                    $page eq "exec.html")
                {
                    next;
                }
                $page =~ s/\.html$/\.prehtml/g;
                push(@pagea,$page);
            }
        }
    }
}
close(TFD);

my $tmpfile="./all.prehtml";

open(TFD2,">$tmpfile") or die "could not open for writing $tmpfile:$!";

print TFD2 "<#include file=\"$tocfile\">\n";

@pagea=&uniq(@pagea);

foreach (@pagea)
{
    print TFD2 "<#include file=\"$_\">\n";
}
close (TFD2);

if (-f $tmpfile)
{
    my $command="htmlpp $tmpfile -o Count${cver}/CountAll.html";
    print "$command\n";
    system($command);
}

unlink($tmpfile);

sub uniq 
{
    my(@input) = @_;

    my(@output) = ();

    my  $last = 'A Dummy Record';
    my $line;
    foreach $line (@input)
    {
        if ($line eq $last)
        {
#            print STDERR "########################\n";
#            print STDERR "Duplicate record:\n$line\n";
            next;
        }
        else
        {
            push(@output,$line);
            $last = $line;
        }
    }

    return @output;
}

