#!/usr/bin/perl

# muquit, Sep-04-1999
# put prev, toc, and next in the page. parse toc.prehtml file

use strict;


my $argc=$#ARGV+1;
my $me=$0;
$me =~ s!.*/!!;
my $g_debug=0;

my $usage="

(program to insert navigation (prev,toc,next) images in document, by muquit)

usage: $me toc.prehtml

";

my $hline="
    <table border=0 cellspacing=0 cellpadding=0 width=\"50%\">
        <tr>
            <td bgcolor=\"#6699cc\" colspan=2>
               <table border=0 cellspacing=0 cellpadding=0>
                    <tr>
                        <td height=2></td>
                    </tr>
               </table>

            </td>
        </tr>
    </table>
";

if ($argc != 1)
{
    print STDERR $usage;
    exit;
}
my $tocfile=$ARGV[0];

my ($line,$junk,$page)='';

my $cver="2.6";
my $dir="./Count${cver}";

my @pagea=();

open(TFD,$tocfile) or die "could not open toc file: $tocfile: $!";


while (<TFD>)
{
    $line=$_;
    chomp($line);

    $line =~ s/^\s+//g;
    if ($line =~ /^<li>/)
    {
        ($junk,$page)=split(/\//,$line);
        $page =~ s/\".*//g;
        if ($page and $page =~ /\.html/)
        {
            $page =~ s/<#d>/Count${cver}/g;
            if ($page !~ /.html#/)
            {
                if ($page eq "examples.html")
                {
                    next;
                }
                push(@pagea,$page);
            }
        }
    }
}
close(TFD);

my ($prev,$toc,$next)='';
my $i=0;
my $items=scalar(@pagea);

foreach $page (@pagea)
{
    $prev='';
    $toc='';
    $next='';
    $toc="../Count.html";

    if (($i-1) >= 0)
    {
        $prev=$pagea[$i-1];
    }

    if (($i+1) < $items)
    {
        $next=$pagea[$i+1];
    }
    else
    {
        $next='';
    }

    if ($i > 0)
    {
        ;
    }
    else
    {
        $prev='';
    }

    &addNavs($page,$prev,$toc,$next);

    $i++;
}

#
sub addNavs
{
    my $page_html=shift;
    my $prev=shift;
    my $toc=shift;
    my $next=shift;

    my $tmpfile='';
    my $page_prehtml='';
    my ($mid,$left,$min,$right)='';
    my $rc=0;
    my $tmpfile="./tmp/count_nav.$$";

    $page_prehtml=$page_html;
    $page_prehtml =~ s/.html/\.prehtml/;

    $page_html="$dir/$page_html";
    my $donav_file="./tmp/$page_prehtml.donav";
    my @whole_file=();


    print "page=$page_html\n" if $g_debug;


    # only if $donav_file exists, put the nav images
    if (! -f $donav_file)
    {
        return;
    }
    # get rid of the nav file
    unlink($donav_file);

        # open the page for reading
        unless (open(FD,"$page_html"))
        {
            print STDERR "could not open for writing: $page_html\n";
            return;
        }
        @whole_file=(<FD>);
        close(FD);

        if ( -f $page_html)
        {
            # open temporary file to write the navs
            unless (open(TTFD,">>$tmpfile") )
            {
                print "could not open file: $tmpfile\n";
                return;
            }
        }


        foreach (@whole_file)
        {
            if ($_ =~ /\<body bgcolor=/)
            {
                print TTFD $_;

                if (-f $page_html)
                {
                    print TTFD "<!--COUNT_NAV_START-->\n";
                    if ($prev)
                    {
                        print TTFD <<EOF;
            <a href="$prev"><img src="images/prev.png" alt="$prev" border=1></a>
EOF
;

        }
                    print TTFD <<EOF;
<a href="$toc"><img src="images/toc.png" alt="Contents" border=1></a>
EOF
;
                    if ($next)
                    {
                        print TTFD <<EOF;
<a href="$next"><img src="images/next.png" alt="$next" border=1></a>
EOF
;
                    }

                    print TTFD "<p>$hline<br>\n";
                    print TTFD "<!--COUNT_NAV_END-->\n";
                }
            }
            else
            {
                print TTFD $_;
            }
        }


        print TTFD "<!--COUNT_NAV_START-->\n";
        print TTFD "<p>$hline<br>\n";
        if ($prev)
        {
            print TTFD <<EOF;
<a href="$prev"><img src="images/prev.png" alt="$prev" border=1></a>
EOF
;
        }
        print TTFD <<EOF;
<a href="$toc"><img src="images/toc.png" alt="Contents" border=1></a>
EOF
;
        if ($next)
        {
            print TTFD <<EOF;
<a href="$next"><img src="images/next.png" alt="$next" border=1></a>
EOF
;
        }
        print TTFD "<br><br><br>\n";
        print TTFD "<!--COUNT_NAV_END-->\n";
        print TTFD "</body>\n";
        print TTFD "</html>\n";
        close(TTFD);

        print "tmpfile=$tmpfile\n" if $g_debug;
        print "page=$page_html\n" if $g_debug;
        rename($tmpfile,$page_html)
}

#
# arg: file1, file2
# returns 1 if file 1 is newer than file 2, 0 otherwise
#
sub prehtmlChanged
{
    my $file_prehtml=shift;
    my $file_html=shift;
    my @fa=();
    my @fb=();
    my $pt;
    my $ht;

    @fa=stat($file_prehtml);
    @fb=stat($file_html);

    # last modified time
    $pt=$fa[9];
    $ht=$fb[9];

#    print "$pt, $ht\n";

    if ($pt && $ht)
    {
        if ($pt > $ht)
        {
            return(1);  # changed
        }
    }

    return (0);
}
